#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int,int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9 + 5;
#define MAXN 200005

int n, p, q, S, A[MAXN], B[MAXN];
int main() {
  cin >> n >> p >> q >> S;
  REP(i,0,p) cin >> A[i];
  map<int,int> cntOrig, cnt;
  REP(i,0,q) {
    cin >> B[i];
    cntOrig[B[i]]++;
  }
  sort(A, A + p);
  int l = 0, r = INF;
  while (l <= r) {
    int D = (l + r) / 2;

    cnt = cntOrig;
    int matched = 0;
    for (int i = p - 1; i >= 0; i--) {
      int bound = min(A[i] + D, S - A[i]);
      if (bound < A[i] - D) continue;
      map<int,int>::reverse_iterator r(cnt.upper_bound(bound));
      if (r == cnt.rend() || r->first < A[i] - D) continue;
      if (r->second == 1) cnt.erase(r->first);
      else r->second--;
      if (++matched >= n) break;
    }
    if (matched >= n) r = D - 1;
    else l = D + 1;
  }
  cout << (l >= INF ? -1 : l) << endl;
  return 0;
}
