import java.io.*;
import java.util.*;

// Doesn't handle duplicates in B
public class ICPCCamp_Arknave_DuplicatesB {
    static long INF = 1000000007;
    public static void main(String[] args) throws IOException {
        Scanner scan = new Scanner(System.in);
        int n = scan.nextInt();
        int p = scan.nextInt();
        int q = scan.nextInt();
        long s = scan.nextLong();

        long[] a = new long[p];
        for (int i = 0; i < p; i++) {
            a[i] = scan.nextLong();
        }

        long[] b = new long[q];
        for (int i = 0; i < q; i++) {
            b[i] = scan.nextLong();
        }

        Arrays.sort(a);
        // reverse the array
        for (int i = 0, j = p - 1; i < j; i++, j--) {
            long t = a[i];
            a[i] = a[j];
            a[j] = t;
        }

        long lo = -1;
        long hi = INF;
        while (lo + 1 < hi) {
            long mid = (lo + hi) / 2;
            TreeSet<Long> ts = new TreeSet<>();
            for (long x : b) {
                ts.add(x);
            }
            int hits = 0;
            for (long x : a) {
                Long y = ts.floor(Math.min(s - x, x + mid));
                if (y != null && y >= x - mid) {
                    ++hits;
                    ts.remove(y);
                }
            }

            if (hits >= n) {
                hi = mid;
            } else {
                lo = mid;
            }
        }

        if (hi == INF)
            hi = -1;

        System.out.println(hi);
    }
}
